pipeline {
  agent any
    
  tools {nodejs "NodeJS"}
    
  stages {
     
    stage('Build') {
      steps {
        sh 'npm install'
        echo '*******************************'
        sh 'npm run get-version'
        echo '*******************************'
        sh 'npm run build-ci'
        archiveArtifacts artifacts: '*.*'
      }
    }  
    
    stage('Test') {
      parallel {

        stage('With-coverage') {
          when {
              expression {
                  env.TEST_WITH_COVERAGE == 'true'
              }
          }
          steps {
              sh 'npm run test-ci'
          }
        }

        stage('Without-coverage') {
          when {
              expression {
                  env.TEST_WITH_COVERAGE == 'false'
              }
          }
          steps {
              sh 'npm run test-ci-without-coverage'
          }
        }
      }
    }

  }
}
